/*
 * Copyright (c) 1998 Marius Gedminas <mgedmin@pub.osf.lt>
 *
 *     This program is free software; you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation; either version 2 of the License, or
 *     (at your option) any later version.
 *
 *     This program is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with this program; if not, write to the Free Software
 *     Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <stdarg.h>
#include <stdlib.h>
#include <string.h>

#include "util.h"

char * 
concat(const char * s, ...)
{
  va_list ap;
  size_t len;
  char * buf, * p;
  
  if (s == NULL)
    return NULL;
    
  len = strlen(s);
  va_start(ap, s);
  while ((p = va_arg(ap, char *)) != NULL)
    len += strlen(p);
  va_end(ap);
  
  buf = (char *) malloc(len+1); 
  strcpy(buf, s);
  va_start(ap, s);
  while ((p = va_arg(ap, char *)) != NULL)
    strcat(buf, p);
  va_end(ap);
  
  return buf;
}
